Windows - bundled extension gems compile, but don't copy *.so files to lib folder

11/23/2022 02:43 PM - MSP-Greg (Greg L)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v:  Backport: 2.7: UNKNOWN, 3.0: UNKNOWN, 3.1:

UNKNOWN

Description

Just finished updating ruby-loco's mswin build to use a system similar to the ucrt & mingw builds.

Confirmed something I noticed previously, and also occurs with the RubyInstaller2 head build.

On Windows, bundled extension gems (debug, rbs) compile their extension in the ext folder, but do not copy them to the lib folder. 

So, the *.so file is created, but not copied.

I think this was working correctly on Ruby 3.1?

History

#1 - 11/24/2022 02:27 AM - alanwu (Alan Wu)

Does that mean the native extensions of those gems don't work when one tries to load them after installation?

#2 - 11/24/2022 03:49 AM - MSP-Greg (Greg L)

@alanwu (Alan Wu)

Thanks. A bit of 'multi-tasking brain freeze' going on this morning.

Or, yes they do work without a copy in the lib folder.

Please close...

#3 - 11/24/2022 05:09 PM - alanwu (Alan Wu)

- Status changed from Open to Closed

#4 - 12/01/2022 06:27 AM - nobu (Nobuyoshi Nakada)

It is intended.

*.so files are architecture-dependent, which are "tainted" in other words, while lib directories are architecture-independent, "untainted".

"Tainted" files should not infect "untainted" directories.

#5 - 12/01/2022 03:00 PM - MSP-Greg (Greg L)

@nobu (Nobuyoshi Nakada)

Yes, I agree, it might be very helpful when one has more than one platform installed and uses --user-install. As in Gem.install_extension_in_lib, also 

Gem::Ext::ExtConfBuilder.  I overwrite my Windows Ruby master installs daily, so I always use --user-install.

Maybe issues with existing extension gems that load with require_relative, and also pre-compiled gems?
